library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity H_control is
	port(
			clk		:	in std_logic;
			Hcount	:	in unsigned(9 downto 0);
			Pattern_H	:	in	integer;
			locate	:	in	integer;
			Hcounter	:	buffer integer;
			flag_h	:	out	std_logic
			);
end entity H_control;

architecture rtl of H_control is
  constant HSYNC        : integer := 96;
  constant HBACK_PORCH  : integer := 48;
begin
	process(clk)
	begin
		if rising_edge(clk) then
--			if locate > 20 then
				if Hcount < HSYNC + HBACK_PORCH - 1 + locate  then
					flag_h <= '0';
				elsif Hcount = HSYNC + HBACK_PORCH - 1 + locate  then
					flag_h <= '1';
					Hcounter <= 0;
				elsif Hcount > HSYNC + HBACK_PORCH - 1 + locate  and Hcount < HSYNC + HBACK_PORCH - 1 + locate + Pattern_H then
					Hcounter <= Hcounter +1;
				elsif Hcount >= HSYNC + HBACK_PORCH - 1 + locate + Pattern_H then
					Hcounter <= 0;
					flag_h <= '0';
				end if;
--			else
--				flag_h<='0';
--			end if;
		end if;
	end process;
end rtl;