library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity V_control is
	port(
			clk		:	in std_logic;
			Vcount	:	in unsigned(9 downto 0);
			Pattern_V	:	in	integer;
			locate	:	in	integer;
			Vcounter	:	buffer integer;
			flag_v	:	out	std_logic;
			reset_n	:	in		std_logic;
			EndofLine:	in	std_logic
			);
end entity V_control;

architecture rtl of V_control is
  constant VSYNC        : integer := 2;
  constant VBACK_PORCH  : integer := 33;
begin
	process(clk)
	begin
		if rising_edge(clk) then
			if reset_n = '0' then
				flag_v <= '0';
			elsif	EndofLine = '1' then
				if Vcount < VSYNC + VBACK_PORCH - 1 + locate then
					flag_v <= '0';
				elsif Vcount = VSYNC + VBACK_PORCH - 1 + locate then
					flag_v <= '1';
					Vcounter <= 0;
				elsif Vcount > VSYNC + VBACK_PORCH - 1 + locate and Vcount < VSYNC + VBACK_PORCH - 1 + locate + Pattern_V then
					Vcounter <= Vcounter +1;
				elsif Vcount >= VSYNC + VBACK_PORCH - 1 + locate + Pattern_V then
					Vcounter <= 0;
					flag_v <= '0';
				end if;
			end if;
		end if;
	end process;
end rtl;